#Command Loader
#

# module Envoi
#   module Mam
#     class Agent
#       class CLI
#         class Commands
#
#
#           # Commands
#         end
#
#         # CLI
#       end
#
#       # Agent
#     end
#
#     # Mam
#   end
#
#   # Envoi
# end

@commands_dir = File.join(File.dirname(__FILE__), 'commands')
@command_ext = '.rb'

@command_list_str = ''
@commands = [ ]
@command_aliases = { }

def build_command_aliases(commands_dir = @commands_dir)
  Dir.glob(File.join(commands_dir, "*.rb")).each do |fn|
    command_file_name = File.basename(fn)
    command_name = File.basename(command_file_name, '.*')
    command_alias = command_name.tr('-_', '')
    @commands << command_name
    @command_aliases[command_alias] = command_name
    @command_list_str += "\n\t - #{command_name}"
  end
end

def usage

  <<-EOT
Usage: #{File.basename($0)} COMMAND [ARGS]
  
  Available Commands:
    #{@command_list_str}
    
All commands can be run with -h (or --help) for more information.
  EOT
end


build_command_aliases
if ARGV.empty?
  should_show_usage = true
else
  command_name = ARGV.first.dup
  command_name = @command_aliases[command_name] || command_name
  should_show_usage = %w(-h --help).include?(command_name.downcase)
end
if should_show_usage
  puts usage
  exit(true)
end

command_file_path = File.join(@commands_dir, command_name)
abort(usage) unless File.exist?("#{command_file_path}#{@command_ext}")

require 'envoi/mam/agent/cli'

begin
  require "#{command_file_path}#{@command_ext}"
rescue LoadError => e
  abort(e.message)
end


# Execute the command if it is in object form, otherwise it's just a script and executed when we required it
if Envoi::Mam::Agent::CLI.const_defined?('Commands')
  command_class_name = command_name.to_s.capitalize
  if Envoi::Mam::Agent::CLI::Commands.const_defined?(command_class_name)
    command_object = Envoi::Mam::Agent::CLI::Commands.const_get(command_class_name.capitalize ) rescue nil
  end
  command_object ||= begin
    command_class_name = command_class_name.upcase
    Envoi::Mam::Agent::CLI::Commands.const_defined?(command_class_name) ? Envoi::Mam::Agent::CLI::Commands.const_get(command_class_name ) : false
  end
  if command_object
    command_instance = command_object.new if command_object.respond_to?(:new)
    command_instance.execute if command_instance.respond_to?(:execute)
  end
end



