
require 'envoi/mam/agent'

module Envoi
  module Mam
    class Agent
      class TransferClient

        attr_accessor :agent, :logger, :initial_args

        def initialize(args = { })
          @initial_args = args
          @agent = args[:agent]
          initialize_logger(args)

          after_initialize
        end

        def after_initialize
          # To be overridden by child class
        end

        def initialize_logger(args = { })
          @logger = agent.logger if agent && agent.respond_to?(:logger) && agent.logger
        end

        # TransferClient
      end

      # Agent
    end

    # Mam
  end

  # Envoi
end